/************************************************************************/
/*                                                                      */
/************************************************************************/
function G_LoadSettings() {
    G_Debug("G_LoadSettings() start")
    var settings = System.Gadget.Settings;
    $(":input").each(function(i) {
        var propName = this.id;
        var propValue = settings.read(propName);
        var type = $(this).attr("type");
        G_Debug(propName + "=" + propValue);
        
        
        if(type == "checkbox") {
            $(this).attr("checked",propValue);
        } else {
            $(this).val(propValue);
        }
    });
    G_Debug("G_LoadSettings() end");
}

function G_OnSettingsClosing(e) {
    G_Debug("G_OnSettingClosing(e)");
    // Save the settings if the user clicked OK.
    if (e.closeAction == e.Action.commit)
    {
        var settings = System.Gadget.Settings;
        
        // Input Tag
        $(":input").each(function(i) {
            var propName = this.id;
            var propValue = null;
            
            if($(this).attr("type") == "checkbox") {
                propValue = $(this).attr("checked");
            } else {
                propValue = $(this).val();
            }
            if(propValue == null || propValue == "") {
                if($(this).hasClass("has-color-picker")) {
                    propValue = $("#color-picker-" + $(this).id).color;   
                }
            }
            settings.write(propName, propValue);
            G_Debug("write:" + propName + "=" + propValue);
        });
    } 
    // Allow the Settings dialog to close.
    e.cancel = false;

}

function G_Debug(msg) {
    $("#debug-pane").append("<div>" + msg + "<div>");
}
/************************************************************************/
/* Main                                                                     */
/************************************************************************/
System.Gadget.onSettingsClosing = G_OnSettingsClosing;

$(document).ready(function(){
    G_LoadSettings();
    
    
    $("#tabs > ul").tabs();
	
    // Setting 'About' tag.
    $("#version").text(System.Gadget.version);
    $("#project-page").append('<a href="http://code.google.com/p/skype-vista-gadget/?' + System.Gadget.version + '">Click here.</a>');
    
	//Preview switch
    $("#StyleSelector").change(function(){
        var str = "";
        $("#StyleSelector option:selected").each(function(){
            str += "theme/" + $(this).val() + "/preview.png";
        });
        $("#StylePreview").attr("src", str);
    }).change();
    
        
});